<?php
class SuperCache
{
	function __construct()
	{}
	
	public static function set($key,$val,$tags,$expire,$type='jtl',$oPlugin=false)
	{
		$now = time();
		if($type == 'jtl')
			Shop::Cache()->set($key,$val,$tags,$expire);
		elseif($type=='mysql')
		{
			self::checkCron();
			if($expire < 1) $expire = time() + (60*60*24*7); //1 Woche
			Shop::Cache()->set($key,$now,$tags,$expire);
			Shop::DB()->query('INSERT INTO xplugin_km_supercache_data SET
					`url`=\''.$key.$now.'\',
					`source`=\''.Shop::DB()->escape($val).'\',
					`lifetime`='.intval($expire).'
				ON DUPLICATE KEY UPDATE
					`source`=\''.Shop::DB()->escape($val).'\',
					`lifetime`='.intval($expire).'
			',1);
		} elseif($type=='file')
		{
			self::checkCron();
			if($expire < 1) $expire = time() + (60*60*24*30); //1 Monat
			Shop::Cache()->set($key,$now,$tags,$expire);
			file_put_contents(PFAD_ROOT.'includes/plugins/'.$oPlugin->cVerzeichnis.'/version/'.$oPlugin->nVersion.'/frontend/cache/'.crc32($key).$now.'.html',$val);
		}
		
		//Now set global timestamp to revalidate it!
		Shop::Cache()->set('supercachetime',$now,['supercache']);
	}
	
	public static function get($key,$type='jtl',$oPlugin=false)
	{
		if($type=='jtl')
			return Shop::Cache()->get($key);
		elseif($type == 'mysql')
		{
			$time = Shop::Cache()->get($key);
			$res = Shop::DB()->select('xplugin_km_supercache_data','url',$key.$time);
			return ($res) ? $res->source : false;
		} elseif($type == 'file') {
			$time = Shop::Cache()->get($key);
			return @file_get_contents(PFAD_ROOT.'includes/plugins/'.$oPlugin->cVerzeichnis.'/version/'.$oPlugin->nVersion.'/frontend/cache/'.crc32($key).$time.'.html');
		}
		
		return false;
	}
	
	public static function php($code)
	{
		$cache_id = '';
		eval($code);
		return $cache_id;
	}
	
	public static function checkCron()
	{
		//Method needs a Cronjob, so check if it is registered, if not do so!
		$res = Shop::DB()->select('tcron','cJobArt','supercache');
		if(!$res)
		{
			$data = new stdClass;
			$data->cJobArt = 'supercache';
			$data->nAlleXStd = 1;
			$data->cName = 'SuperCache Bereinigung';
			Shop::DB()->insert('tcron',$data);
		}
	}
	public static function pluginAvailable($pluginId) {

		if (empty($pluginId)) return false;

		$plugin = Plugin::getPluginById($pluginId);

		if(!empty($plugin) && $plugin->nStatus == 2) return true;
			return false;

	}
}